local helper = wesnoth.require "lua/helper.lua"

wesnoth.wml_actions.event{
	name="attack" ,
	id="nrm_attack_event",
	first_time_only=false,
	{ "nrm_remove_randomness", {
		{ "filter" , {
			id="$unit.id"
		}},
		{ "filter_second" , {
			id="$second_unit.id"
		}}
	} }
}
wesnoth.wml_actions.event{
	name="attack end",
	id="nrm_post_attack_event",
	first_time_only=false,
	{ "nrm_restore_properties", {
		id="$unit.id"
	}},
	{ "nrm_restore_properties", {
		id="$second_unit.id"
	}}
}

function wesnoth.deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
	copy = {}
	for orig_key, orig_value in next, orig, nil do
	    copy[wesnoth.deepcopy(orig_key)] = wesnoth.deepcopy(orig_value)
	end
	setmetatable(copy, wesnoth.deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
	copy = orig
    end
    return copy
end

function wesnoth.wml_actions.nrm_remove_randomness(cfg)
	local filter = helper.get_child(cfg, "filter")
	local u1 = wesnoth.get_units(filter)[1]
	filter = helper.get_child(cfg, "filter_second")
	local u2 = wesnoth.get_units(filter)[1]
	local function modify_unit_for_no_random(attacker,defender)
		local defense = wesnoth.unit_defense ( defender, wesnoth.get_terrain ( defender.x,  defender.y ) )
		local attacker_code = attacker.__cfg
		local variables_pos
		local backup_pos
		for i = 1,#attacker_code do
			if attacker_code[i][1] == "variables" then
				variables_pos = i
				backup_pos = #attacker_code[i][2] + 1
				attacker_code[i][2][backup_pos] = { "nrm_backup" , {}}
			end
		end
		for i = 1,#attacker_code do
			if attacker_code[i][1] == "attack" then
				table.insert(attacker_code[variables_pos][2][backup_pos][2], wesnoth.deepcopy(attacker_code[i]) )
				local has_specials=false
				for j=1,#attacker_code[i][2] do
					if attacker_code[i][2][j][1] == "specials" then
						has_specials=true
						local this_defense = defense * 1
						for k=1,#attacker_code[i][2][j][2] do
							if attacker_code[i][2][j][2][k][1] == "chance_to_hit" then
								if attacker_code[i][2][j][2][k][2].active_on ~= "offense" or attacker_code.id == u1.id then
									if attacker_code[i][2][j][2][k][2].active_on ~= "defense" or attacker_code.id == u2.id then
										if attacker_code[i][2][j][2][k][2].value then
											if attacker_code[i][2][j][2][k][2].cumulative ~= true or this_defense < attacker_code[i][2][j][2][k][2].value then
												this_defense = attacker_code[i][2][j][2][k][2].value
											end
										end
										if attacker_code[i][2][j][2][k][2].add then
											this_defense = this_defense + attacker_code[i][2][j][2][k][2].add
										end
										if attacker_code[i][2][j][2][k][2].sub then
											this_defense = this_defense - attacker_code[i][2][j][2][k][2].sub
										end
										if attacker_code[i][2][j][2][k][2].multiply then
											this_defense = this_defense * attacker_code[i][2][j][2][k][2].multiply
										end
										if attacker_code[i][2][j][2][k][2].divide then
											this_defense = this_defense - attacker_code[i][2][j][2][k][2].divide
										end
										--wesnoth.wml_actions.message{ speaker="narrator", message=this_defense }
									end
								end
								attacker_code[i][2][j][2][k][2].value=nil
								attacker_code[i][2][j][2][k][2].add=nil
								attacker_code[i][2][j][2][k][2].sub=nil
								attacker_code[i][2][j][2][k][2].divide=nil
								attacker_code[i][2][j][2][k][2].multiply=nil
								attacker_code[i][2][j][2][k][2].cumulative=nil
							end
						end
						table.insert( attacker_code[i][2][j][2] , { "chance_to_hit" , { id="nrm_effect", value=100 } } )
						attacker_code[i][2].damage = (attacker_code[i][2].damage * this_defense) / 100
					end
				end
				if has_specials == false then
					table.insert( attacker_code[i][2] ,{ "specials", { { "chance_to_hit" , { id="nrm_effect", value=100 } } }})
					attacker_code[i][2].damage = (attacker_code[i][2].damage * defense) / 100
				end
			end
		end
		wesnoth.put_unit(attacker_code)
	end
	modify_unit_for_no_random(u1,u2)
	modify_unit_for_no_random(u2,u1)
end

function wesnoth.wml_actions.nrm_restore_properties(cfg)
	local u = wesnoth.get_units(cfg)[1]
	if u then
		local unit = u.__cfg
		for i = 1,#unit do
			if unit[i][1] == "variables" then
				for j = 1,#unit[i][2] do
					if unit[i][2][j][1] == "nrm_backup" then
						local attack_num = 1
						for k = 1,#unit do
							if unit[k][1] == "attack" then
								unit[k] = wesnoth.deepcopy(unit[i][2][j][2][attack_num])
								attack_num = attack_num + 1
							end
						end
						table.remove(unit[i][2], j)
					end
				end
			end
		end
		wesnoth.put_unit(unit)
	end
end
